<script setup lang="ts">
import { nextTick, ref, onMounted } from "vue";
import axios, {type AxiosResponse} from 'axios';
import router from "../router/index";
import { useCookies } from "vue3-cookies";
const { cookies } = useCookies();
const backendURL = import.meta.env.VITE_BACKEND_URL;
interface User {
    _id: String;
  email: String;
  nama_lengkap: String;
  nomor_telepon: String;
  role: String;
}
let userArr = ref([] as User[])

onMounted(async () => {
    if (!cookies.get("authorization")) {
      router.push("/")
    }
})


let isSearch = false;
let loadInitialItems = async function(){ 
    await axios.post(`${backendURL}/user/all`, {
    },  
    {
        headers: {
            // @ts-ignore
            'authorization' : 'Bearer ' + cookies.get("authorization")
        }
    }
    ).then((response) => {
        for (let i = 0; i < response.data.length; i++) {
            userArr.value.push({
            // @ts-ignore
            _id: response.data[i]._id,
            // @ts-ignore
            email : response.data[i].email,
            // @ts-ignore
            nama_lengkap : response.data[i].nama_lengkap,
            // @ts-ignore
            nomor_telepon: response.data[i].nomor_telepon,
            // @ts-ignore
            role: response.data[i].role
            })
        }
        console.log(userArr)
    }).catch((error) => {
        console.log(error.response.data)
    });
}

let loadSearchUserByName = async function(){ 
    userArr.value = [];
    let query = (<HTMLInputElement>(document.getElementById('search-input')))?.value
    if (!query) {
        isSearch = false;
        loadInitialItems();
        return;
    } else {
        isSearch = true;
    }
    console.log(isSearch)
    await axios.post(`${backendURL}/user/name`, {
        "nama_lengkap": (<HTMLInputElement>(document.getElementById('search-input')))?.value
    },  
    {
        headers: {
            // @ts-ignore
            'authorization' : 'Bearer ' + cookies.get("authorization")
        }
    }
    ).then((response) => {
        for (let i = 0; i < response.data.length; i++) {
            userArr.value.push({
            // @ts-ignore
            _id: response.data[i]._id,
            // @ts-ignore
            email : response.data[i].email,
            // @ts-ignore
            nama_lengkap : response.data[i].nama_lengkap,
            // @ts-ignore
            nomor_telepon: response.data[i].nomor_telepon,
            // @ts-ignore
            role: response.data[i].role
            })
        }
        console.log(userArr)
    }).catch((error) => {
        console.log(error.response.data)
    });
}

let loadMoreItems = async function(){ 
    
    if (isSearch) {
        await axios.post(`${backendURL}/user/name/next`, {
            // @ts-ignore
            "last_email": userArr.value[userArr.value.length - 1].email 
        },  
        {
            headers: {
                // @ts-ignore
                'authorization' : 'Bearer ' + cookies.get("authorization")
            }
        }
        ).then((response) => {
            for (let i = 0; i < response.data.length; i++) {
                userArr.value.push({
                // @ts-ignore
                _id: response.data[i]._id,
                // @ts-ignore
                email : response.data[i].email,
                // @ts-ignore
                nama_lengkap : response.data[i].nama_lengkap,
                // @ts-ignore
                nomor_telepon: response.data[i].nomor_telepon,
                // @ts-ignore
                role: response.data[i].role
                })
            }
            console.log(userArr)
        }).catch((error) => {
            console.log(error.response.data)
        });
    } else {
        await axios.post(`${backendURL}/user/all/next`, {
            // @ts-ignore
            "last_email": userArr.value[userArr.value.length - 1].email 
        },  
        {
            headers: {
                // @ts-ignore
                'authorization' : 'Bearer ' + cookies.get("authorization")
            }
        }
        ).then((response) => {
            for (let i = 0; i < response.data.length; i++) {
                userArr.value.push({
                // @ts-ignore
                _id: response.data[i]._id,
                email : response.data[i].email,
                nama_lengkap : response.data[i].nama_lengkap,
                nomor_telepon: response.data[i].nomor_telepon,
                role: response.data[i].role
                })
            }
            console.log(userArr)
        }).catch((error) => {
            console.log(error.response.data)
        });
    }
    
}

let deleteUser = async function(id: string){
    let isDelete = confirm("Apakah anda yakin ingin menghapus user ini?");
    if (isDelete) {
        await axios.delete(`${backendURL}/user/delete/` + id, {
            headers: {
                // @ts-ignore
                'authorization' : 'Bearer ' + cookies.get("authorization")
            }
        }
        ).then((response) => {
            console.log(response)
            // refresh
            window.location.reload()
        }).catch((error) => {
            console.log(error.response.data)
        });
    }
}


loadInitialItems()
</script>

<template>
  <!-- content goes here -->
  <div class="pt-1 text-black flex flex-row justify-center">
    <div class="flex-1 pt-6 px-6 corpusdetail">
      <div class="searchbox flex flex-row">
        <img alt="search logo" class="mx-3" src="@/assets/search.svg" width="16" height="16" />
        <input 
          v-on:keyup.enter="loadSearchUserByName()"
          class="border-l border-neutral-400 px-3 searchinput active:border-0 align-middle grow" 
          id="search-input"
          placeholder="Search"
        />
      </div>
      <div class="corpuslist">
        <table style="width:100%" id="user-table">
            <tr>
                <th>Email</th>
                <th>Nama Lengkap</th> 
                <th>Nomor Telepon</th>
                <th>Role</th>
                <th>Action</th>
            </tr>
            <tr v-for="(user, index) in userArr" :key="index">
                <td>{{user.email}}</td>
                <td>{{user.nama_lengkap}}</td>
                <td>{{user.nomor_telepon}}</td>
                <td>{{user.role}}</td>
                <td>
                    <div v-if="cookies.get('email') !=   user.email" class="flex flex-row">
                        <RouterLink :to="`/panel/update/${user._id}`"><button class="navbutton text-white mb-3 content-center">Edit</button></RouterLink>
                        <button @click="deleteUser(user._id.toString())" class="navbutton text-white mb-3 content-center">Delete</button>
                    </div>
                </td>
            </tr>

        </table>
        </div>
        <button @click="loadMoreItems()" class="navbutton text-black mb-3 content-center">Load More</button>
    </div>
  </div>
</template>

<style>
.bookImage{
  @apply min-w-full;
  object-fit: cover;
}
.corpuslist {
  @apply overflow-y-auto mt-1;
  scroll-behavior: smooth;
  height: 83%;
}
.corpusbook {
  @apply flex-auto min-w-full h-72 overflow-hidden;
  background: #2d2e2d;
  border-radius: 15px;
}
.corpusdetail {
  @apply overflow-y-auto;
  height: 90vh;
}
.booktitle {
  @apply text-5xl;
}
.navbutton {
  max-width: 10rem;
  min-height: 2rem;
  background: #2e694f;
  border-radius: 15px;
  @apply mt-3 mr-1 px-2 hover:bg-emerald-600;
}
.delbutton {
  max-width: 10rem;
  min-height: 2rem;
  background: #821a28;
  border-radius: 15px;
  @apply mt-3 mr-1 px-2 hover:bg-rose-700;
}
.searchinput {
  width: 5rem;
  background: transparent;
  @apply text-black;
}
.searchbox {
  background: #2d2e2d;
  max-width: 50%;
  height: 2rem;
  border-radius: 15px;
}
</style>
